/* tab_size = 4 */

/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*       "EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.      *
*                                                                       *
*  Copyright (C) 1985, 1992 Lugaru Software Ltd.  All rights reserved.  *
*                                                                       *
* Limited permission is hereby granted to reproduce and modify this     *
* copyrighted material provided that the resulting code is used only in *
* conjunction with Lugaru products and that this notice is retained in  *
* any such reproduction or modification.                                *
*************************************************************************
*  The previous copyright and trademark notice applies to some of the   *
*  code herein. All other changes, enhancements and extension routines  *
*                                                                       *
*  Copyright (C) 1992 by Giovanni Zezza                                 *
*                                                                       *
*  These changes may be redistributed free allowed for any purpose      *
*  providing both the Lugaru and my copyrights remain intact.           *
*  I assume no liability for the use or inability to use                *
*  this software. Neither do I take responsibility for any damage       *
*  caused by this software extension.                                   *
*  This extension may NOT be redistributed for profit.                  *
*************************************************************************
* File.......: ZIPLS.H - Header file for Zip List                       *
* Ver........: 1.00                                                     *
* Date.......: 1994-03-03                                               *
* psilon ver: 6.52                                                     *
* By.........: Giovanni Zezza                                           *
*     Address: via Basoli,1                                             *
*              40137 BOLOGNA                                            *
*     Country: ITALY                                                    *
*     Tel....: Int +39-51-623 75 77 (GMT + 1h)                          *
*     Fax....: Int +39-51-33 06 66                                      *
*     FidoNet: 2:332/403 - Active - Bologna - Italy                     *
************************************************************************/

#define Loc_Head_ID "PK\3\4"
#define Dir_Head_ID "PK\1\2"
#define Fine_Dir_ID "PK\5\6"

typedef char  byte;
typedef short word;
typedef int   long;
typedef char  boolean;
typedef char PK_FIRMA[5];

typedef struct {
	word  Versione;            //version needed to extract 2 bytes
	word  FillGenerale;        //general purpose bit flag  2 bytes
	word  MetodoCompressione;  //compression method        2 bytes
	word  Tempo;               //last mod file time        2 bytes
	word  Data;                //last mod file date        2 bytes
	char  crc_32[4];           //crc-32                    4 bytes
	long  LungCompresso;       //compressed size           4 bytes
	long  LungOriginale;       //uncompressed size         4 bytes
	word  LungNome;            //filename length           2 bytes
	word  LungExtraField;      //extra field length        2 bytes
} LOC_HEAD_STRUCT;

typedef union {
        char Buffer[sizeof(LOC_HEAD_STRUCT)];
        LOC_HEAD_STRUCT Record;
} LOC_HEAD_REC;

typedef struct {
	word  ScrittoDa;            //version made by                 2 bytes
	word  Versione;             //version needed to extract       2 bytes 
	word  FillGenerale;         //general purpose bit flag        2 bytes
	word  MetodoCompressione;   //compression method              2 bytes
	word  Tempo;                //last mod file time              2 bytes
	word  Data;                 //last mod file date              2 bytes
	char  crc_32[4];            //crc-32                          4 bytes
	long  LungCompresso;        //compressed size                 4 bytes
	long  LungOriginale;        //uncompressed size               4 bytes
	word  LungNome;             //filename length                 2 bytes
	word  LungExtra;            //extra field length              2 bytes
	word  LungCommento;         //file comment length             2 bytes
	word  DiscoIniziale;        //disk number start               2 bytes
	char  AttributiInterni[2];  //internal file attributes        2 bytes
	char  AttributiEsterni[4];  //external file attributes        4 bytes
	long  OffSet;               //relative offset of local header 4 bytes
} DIR_HEAD_STRUCT;

typedef union {
        char Buffer[sizeof(DIR_HEAD_STRUCT)];
        DIR_HEAD_STRUCT Record;
} DIR_HEAD_REC;

typedef union {
        char Buffer[4];
        long DirOffset;
} DIR_END_REC;

typedef struct {
      char low;
      char hi;
} BYTE_ST;
   
typedef union {
   BYTE_ST b;
   short w;
}WORD_ST;

typedef struct {
   word loword;
   word hiword;
}DOPPIA_PAROLA;
   
typedef union {
   DOPPIA_PAROLA value ;
   char Buffer[4];
} ADDR_ST;

typedef struct
{
   char versione[12];
} PK_VER ;

#ifdef LANGUAGE
#define ST_ZIP_PROMPT  "PkZip file name : "
#define ST_SORRY       "Sorry, some @#?# error!"
#define ST_NO_ZIP_FILE "Don't seems to be a PkZip file"
#define ST_VERSION_LONG "Version"
#define ST_VERSION      "Ver."
#define ST_LEN     "Len"
#define ST_ZIP_LEN "ZipLen"
#define ST_METHOD  "Method"
#define ST_ZIP_RATIO "Zip%"
#define ST_DATE "  Date  "
#define ST_TIME "Time "
#define ST_NAME "Name"
#define ST_READ_ERROR "Reading error"
#define ST_DONE "%d files, done."
#else
#define ST_ZIP_PROMPT "nome file PkZip : "
#define ST_SORRY      "non so che dirti!"
#define ST_NO_ZIP_FILE "Non sembra un file PkZip"
#define ST_VERSION_LONG  "Versione"
#define ST_VERSION "Ver."
#define ST_LEN     "Lunghezza"
#define ST_ZIP_LEN "ZipLungh"
#define ST_METHOD  "Metodo"
#define ST_ZIP_RATIO "Zip%"
#define ST_DATE "  Data  "
#define ST_TIME " Ora "
#define ST_NAME "Nome"
#define ST_READ_ERROR "Errore di lettura"
#define ST_DONE "%d file, fatto."
#endif
