/* tab_size = 8 */

/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	*
*									*
*  Copyright (C) 1985, 1992 Lugaru Software Ltd.  All rights reserved.	*
*									*
* Limited permission is hereby granted to reproduce and modify this	*
* copyrighted material provided that the resulting code is used only in	*
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.				*
*************************************************************************
*  The previous copyright and trademark notice applies to some of the	*
*  code herein. All other changes, enhancements and extension routines	*
*									*
*  Copyright (C) 1992 by Giovanni Zezza					*
*									*
*  These changes may be redistributed free allowed for any purpose	*
*  providing both the Lugaru and my copyrights remain intact.		*
*  I assume no liability for the use or inability to use		*
*  this software. Neither do I take responsibility for any damage	*
*  caused by this software extension.					*
*  This extension may NOT be redistributed for profit.			*
*************************************************************************
* File.......: ZIPLS.E - List files in Zip files (.ZIP & .EXE)          *
* Ver........: 1.00                                                     *
* Date.......: 1994-03-03                                               *
* psilon ver: 6.52							*
* By.........: Giovanni Zezza						*
*     Address: via Basoli,1						*
*              40137 BOLOGNA						*
*     Country: ITALY							*
*     Tel....: Int +39-51-623 75 77 (GMT + 1h)                          *
*     Fax....: Int +39-51-33 06 66					*
*     FidoNet: 2:332/403 - Active - Bologna - Italy			*
************************************************************************/

#include "eel.h"
#include "codes.h"
#include "lowlevel.h"

//If you want english messages
#define LANGUAGE

#include "pkzip.h"

//#define SHOW_OS_VERSION

#define FILE short

command zipls()
{
   struct file_info finfo;
   char nome_file[FNAMELEN],*t;
   int how_many = 0;
   t=" ";
   get_file_dir(nome_file, ST_ZIP_PROMPT);
   if (t = file_match(nome_file, STARTMATCH | LISTMATCH)) {
      do {
	 if (CHECK_FILE == check_file(t, &finfo)) {
	    do_ls_zip(t, &finfo);
	    ++how_many;
	 }
	 check_abort();
      } while (t =  file_match(nome_file, 0));
      say (ST_DONE, how_many);
   }
}

#ifdef SHOW_OS_VERSION
PK_VER Versioni[] = {
   {"DOS - OS/2"},
   {"Amiga"},
   {"VAX/VMS"},
   {"*nix"},
   {"VM/CMS"},
   {"Atari ST"},
   {"OS/2 HPFS"},
   {"Macintosh"},
   {"Z-System"},
   {"CP/M"}
} ;
#endif

do_ls_zip(nome_file, f_info)
char *nome_file;
struct file_info *f_info;
{
   FILE zip_handle;
   short errore;
   int quantiFiles = 0;
   long fpos = 0, lung_tot = 0, zip_tot = 0;
   int giorno, mese, anno;
   int ora, minuti;
   PK_FIRMA Firma;
   LOC_HEAD_REC LocDir;
   DIR_HEAD_REC dirHeader;
   WORD_ST versione;
   ADDR_ST offset;
   char *CheFile;

   Firma[4] = '\0';
   zip_handle = lowopen(nome_file,0);
   if (zip_handle == -1) { 
      file_error(errno, nome_file, ST_SORRY);
      return;
   }
   mark = point;
   errore = lowread(zip_handle, Firma, 4);
   if (errore == -1) goto abort;
   if (!memcmp(Firma, "MZ", 2)) {
      errore = lowseek(zip_handle, 2, FS_ABS);
      if (errore == -1) goto abort;
      errore = lowread(zip_handle, offset.Buffer, 4);
      if (errore == -1) goto abort;
      errore = lowseek(zip_handle,
		       512 * (offset.value.hiword - 1)
		       + offset.value.loword, FS_ABS);
      if (errore == -1) goto abort;
      errore = lowread(zip_handle, Firma, 4);
      if (errore == -1) goto abort;
   }
   if (strcmp(Firma, Loc_Head_ID)) {
      bprintf("* %s : %s\n", nome_file, ST_NO_ZIP_FILE);
      goto fine;
   }
   bprintf("\n File ZIP: %s\n\n", nome_file);
   while (!strcmp(Firma, Loc_Head_ID) && !user_abort) {
      errore = lowread(zip_handle, LocDir.Buffer, sizeof(LOC_HEAD_STRUCT));
      if (errore == -1) break;
      if (LocDir.Record.FillGenerale & 0x08) 
	 lowseek(zip_handle, 12, FS_REL);
      fpos = lowseek(zip_handle,
		     LocDir.Record.LungCompresso +
		     LocDir.Record.LungNome +
		     LocDir.Record.LungExtraField, FS_REL);
      if (fpos == -1) break;

      errore = lowread(zip_handle, Firma, 4);
      if (errore == -1) break;
      note("%3.3d%% fatto", fpos * 100 / f_info->fsize);
   }
   if (errore == -1 || user_abort) {
      lowclose(zip_handle);
      return;
   }
#ifdef SHOW_OS_VERSION
   bprintf(" %-17.17s  ", ST_VERSION_LONG);
#else
   bprintf(" %-5.5s  ", ST_VERSION);
#endif
   bprintf("%10.10s  %7.7s", ST_LEN, ST_METHOD);
   bprintf("  %8.8s  %4.4s", ST_ZIP_LEN,  ST_ZIP_RATIO);
   bprintf("  %8.8s  %5.5s", ST_DATE, ST_TIME);
   bprintf("  %-4.4s\n", ST_NAME);
#ifdef SHOW_OS_VERSION
   bprintf(" %-17.17s  ", "-----------------");
#else
   bprintf(" %-5.5s  ", "-----");
#endif
   bprintf("%10.10s%9.9s", "----------", " -------");
   bprintf("%10.10s%6.6s", "  --------", "  ----");
   bprintf("%10.10s%7.7s", "  --------", "  -----");
   bprintf("%-10.10s%\n",    "  --------");
   while (!strcmp(Firma, Dir_Head_ID) && !user_abort) {
      errore = lowread(zip_handle, dirHeader.Buffer, sizeof(DIR_HEAD_REC));
      if (errore == -1) break;
      CheFile = malloc(dirHeader.Record.LungNome + 1);
      CheFile[dirHeader.Record.LungNome] = '\0';
      errore = lowread(zip_handle, CheFile, dirHeader.Record.LungNome);
      if (errore == -1) {
	 free(CheFile);
	 break;
      }
      versione.w = dirHeader.Record.ScrittoDa;
#ifdef SHOW_OS_VERSION
      if (versione.b.hi >= 0 && versione.b.hi < 10) {
	 bprintf(" %-10.10s ", Versioni[versione.b.hi].versione);
      } else {
	 bprintf(" %-10.10s ", "???");
      }
#endif
      bprintf(" %2d.%02d  ", versione.b.low/10, versione.b.low % 10);

      anno = dirHeader.Record.Data;
      mese = dirHeader.Record.Data;
      giorno = dirHeader.Record.Data;
      anno >>= 9;
      anno &= 0x7F;
      mese >>= 5; mese &= 0x0F;
      giorno &= 0x1F;
      ora = dirHeader.Record.Tempo;
      minuti = dirHeader.Record.Tempo;
      ora >>= 11; ora &= 0x1F;
      minuti >>= 5; minuti &= 0x3F;

      dirHeader.Record.MetodoCompressione &= 0x0F;
      bprintf("%10d",
	      dirHeader.Record.LungOriginale);
      switch (dirHeader.Record.MetodoCompressione) {
	 case 0:
	    bprintf("  %-7.7s", "Stored"); break;
	 case 1:
	    bprintf("  %-7.7s", "Shrunk"); break;
	 case 2:
	 case 3:
	 case 4:
	 case 5:
	    bprintf("  %-7.7s", "Reduced"); break;
	 case 6:
	    bprintf("  %-7.7s", "Implode"); break;
	 case 7:
	    bprintf("  %-7.7s", "Token"); break;
	 case 8:
	    bprintf("  %-7.7s", "DeflatN"); break;
	 default:
	    bprintf("  %-7.7s", "???");
      }
      if (dirHeader.Record.LungOriginale) {
	 bprintf("  %8d  %3d%%",
		 dirHeader.Record.LungCompresso,
		 100 - dirHeader.Record.LungCompresso * 100 / dirHeader.Record.LungOriginale);
      } else {
	 bprintf("  %8d  %3d%%",
		 dirHeader.Record.LungCompresso,
		 0);
      }

      bprintf("  %02d-%02d-%02d", giorno, mese, anno + 80);
      bprintf("  %02d:%02d", ora, minuti);

      bprintf("  %s\n", CheFile);

      ++quantiFiles;
      lung_tot += dirHeader.Record.LungOriginale;
      zip_tot += dirHeader.Record.LungCompresso;
      free(CheFile);
      maybe_refresh();
      lowseek(zip_handle, dirHeader.Record.LungExtra
	      + dirHeader.Record.LungCommento, FS_REL) ;
      errore = lowread(zip_handle, Firma, 4);
      if (errore == -1) break;
   }
#ifdef SHOW_OS_VERSION
   bprintf(" %-17.17s  ", "     ");
#else
   bprintf(" %-5.5s  ", "     ");
#endif
   bprintf("%10.10s%9.9s", "----------", "        ");
   bprintf("%10.10s%6.6s", "  --------", "  ----");
   bprintf("%10.10s%7.7s", "          ", "       ");
   bprintf("%-10.10s%\n",    "  --------");
#ifdef SHOW_OS_VERSION
   bprintf(" %-17.17s  ", "     ");
#else
   bprintf(" %-5.5s  ", "     ");
#endif
   bprintf("%10d%9.9s", lung_tot, "        ");
   if (lung_tot)
      bprintf("%10d  %3d%%", zip_tot, 100 - zip_tot * 100 / lung_tot);
   else
      bprintf("%10d  %3d%%", zip_tot, 0);
   bprintf("%10.10s%7.7s", "          ", "       ");
   bprintf("  %-10d%\n\n", quantiFiles);
   goto fine;
abort:
   bprintf("\n--- %s : %s ---", nome_file, ST_READ_ERROR);
fine:
   lowclose(zip_handle);
}
